unit uWatchTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, GrohWPC;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Label3: TLabel;
    edResult: TEdit;
    Panel1: TPanel;
    Label1: TLabel;
    edPath: TEdit;                                       
    GroupBox1: TGroupBox;
    cbFiles: TCheckBox;
    cbFolders: TCheckBox;
    cbAttributes: TCheckBox;
    cbSizes: TCheckBox;
    cbWrite: TCheckBox;
    cbSecurity: TCheckBox;
    btStart: TButton;
    GroupBox2: TGroupBox;
    cbSubDirs: TCheckBox;
    Label2: TLabel;
    edTimeOut: TEdit;
    WatchPathChanges1: TWatchPathChanges;
    procedure btStartClick(Sender: TObject);
    procedure WatchPathChanges1WatchDone(WatchStatus: TWatchStatus);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btStartClick(Sender: TObject);
begin
   // Mostrar mensagem de que est observando o diretrio:
   // Show a message saying the folder is being watched:
   edResult.Text := 'Watching...';
   Form1.Refresh;

   // Aproveitar os valores escolhidos pelo operador:
   // Use the operator's entries:
   WatchPathChanges1.WatchPath         := edPath.Text;
   WatchPathChanges1.WatchTimeOut      := StrToInt (edTimeOut.Text);
   WatchPathChanges1.WatchSubTree      := cbSubDirs.Checked;
   WatchPathChanges1.WatchChangeFilter := [];
   if cbFiles.Checked then
      WatchPathChanges1.WatchChangeFilter := WatchPathChanges1.WatchChangeFilter + [WATCH_FILES];
   if cbFolders.Checked then
      WatchPathChanges1.WatchChangeFilter := WatchPathChanges1.WatchChangeFilter + [WATCH_DIR];
   if cbAttributes.Checked then
      WatchPathChanges1.WatchChangeFilter := WatchPathChanges1.WatchChangeFilter + [WATCH_ATTRIBUTES];
   if cbSizes.Checked then
      WatchPathChanges1.WatchChangeFilter := WatchPathChanges1.WatchChangeFilter + [WATCH_SIZE];
   if cbWrite.Checked then
      WatchPathChanges1.WatchChangeFilter := WatchPathChanges1.WatchChangeFilter + [WATCH_LAST_WRITE];
   if cbSecurity.Checked then
      WatchPathChanges1.WatchChangeFilter := WatchPathChanges1.WatchChangeFilter + [WATCH_SECURITY];

   // Disparar o processo:
   // Observe que isto vai pendurar a mquina at que ocorra o evento desejado ou que ocorra Time-Out
   // Para evitar isto, chame o componente em outra thread
   //
   // Trigger the process:
   // Note this may hang your machine until the desired event is signaled or an event time-out occurs
   // In order to avoid it, just call the component using another thread
   WatchPathChanges1.StartWatching;
end;


// Mostrar o resultado:
// Shows the result:
procedure TForm1.WatchPathChanges1WatchDone(WatchStatus: TWatchStatus);
begin
   case WatchStatus of
      TWS_ERROR:   edResult.Text := '*** Error ***';
      TWS_SUCCESS: edResult.Text := 'There are changes';
      TWS_TIMEOUT: edResult.Text := 'No changes were detected (Time-Out)';
   end;
end;

end.
